Index: drivers/filesystems/btrfs/flushthread.c
===================================================================
--- drivers/filesystems/btrfs/flushthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/flushthread.c	(copie de travail)
@@ -1,21 +1,24 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include "btrfs_drv.h"
+#include <ata.h>
+#include <ntddscsi.h>
+#include <ntddstor.h>
 
 #define MAX_CSUM_SIZE (4096 - sizeof(tree_header) - sizeof(leaf_node))
 
@@ -38,55 +41,54 @@
     TREE_BLOCK_REF tbr;
 } EXTENT_ITEM_SKINNY_METADATA;
 
-static NTSTATUS create_chunk(device_extension* Vcb, chunk* c, PIRP Irp, LIST_ENTRY* rollback);
+static NTSTATUS create_chunk(device_extension* Vcb, chunk* c, PIRP Irp);
 static NTSTATUS update_tree_extents(device_extension* Vcb, tree* t, PIRP Irp, LIST_ENTRY* rollback);
-static BOOL insert_tree_item_batch(LIST_ENTRY* batchlist, device_extension* Vcb, root* r, UINT64 objid, UINT64 objtype, UINT64 offset,
-                                   void* data, UINT16 datalen, enum batch_operation operation, PIRP Irp, LIST_ENTRY* rollback);
 
-static NTSTATUS STDCALL write_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#ifndef _MSC_VER // not in mingw yet
+#define DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED 0x80000000
+#endif
+
+_Function_class_(IO_COMPLETION_ROUTINE)
+#ifdef __REACTOS__
+static NTSTATUS NTAPI write_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#else
+static NTSTATUS write_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#endif
     write_context* context = conptr;
-    
+
+    UNUSED(DeviceObject);
+
     context->iosb = Irp->IoStatus;
     KeSetEvent(&context->Event, 0, FALSE);
-    
-//     return STATUS_SUCCESS;
+
     return STATUS_MORE_PROCESSING_REQUIRED;
 }
 
-NTSTATUS STDCALL write_data_phys(PDEVICE_OBJECT device, UINT64 address, void* data, UINT32 length) {
+NTSTATUS write_data_phys(_In_ PDEVICE_OBJECT device, _In_ UINT64 address, _In_reads_bytes_(length) void* data, _In_ UINT32 length) {
     NTSTATUS Status;
     LARGE_INTEGER offset;
     PIRP Irp;
     PIO_STACK_LOCATION IrpSp;
-    write_context* context = NULL;
-    
+    write_context context;
+
     TRACE("(%p, %llx, %p, %x)\n", device, address, data, length);
-    
-    context = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_context), ALLOC_TAG);
-    if (!context) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlZeroMemory(context, sizeof(write_context));
-    
-    KeInitializeEvent(&context->Event, NotificationEvent, FALSE);
-    
+
+    RtlZeroMemory(&context, sizeof(write_context));
+
+    KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+
     offset.QuadPart = address;
-    
-//     Irp = IoBuildSynchronousFsdRequest(IRP_MJ_WRITE, Vcb->device, data, length, &offset, NULL, &context->iosb);
-    
+
     Irp = IoAllocateIrp(device->StackSize, FALSE);
-    
+
     if (!Irp) {
         ERR("IoAllocateIrp failed\n");
-        Status = STATUS_INTERNAL_ERROR;
-        goto exit2;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     IrpSp = IoGetNextIrpStackLocation(Irp);
     IrpSp->MajorFunction = IRP_MJ_WRITE;
-    
+
     if (device->Flags & DO_BUFFERED_IO) {
         Irp->AssociatedIrp.SystemBuffer = data;
 
@@ -95,10 +97,23 @@
         Irp->MdlAddress = IoAllocateMdl(data, length, FALSE, FALSE, NULL);
         if (!Irp->MdlAddress) {
             DbgPrint("IoAllocateMdl failed\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
             goto exit;
         }
-        
-        MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoWriteAccess);
+
+        Status = STATUS_SUCCESS;
+
+        _SEH2_TRY {
+            MmProbeAndLockPages(Irp->MdlAddress, KernelMode, IoReadAccess);
+        } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+            Status = _SEH2_GetExceptionCode();
+        } _SEH2_END;
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+            IoFreeMdl(Irp->MdlAddress);
+            goto exit;
+        }
     } else {
         Irp->UserBuffer = data;
     }
@@ -105,77 +120,345 @@
 
     IrpSp->Parameters.Write.Length = length;
     IrpSp->Parameters.Write.ByteOffset = offset;
-    
-    Irp->UserIosb = &context->iosb;
 
-    Irp->UserEvent = &context->Event;
+    Irp->UserIosb = &context.iosb;
 
-    IoSetCompletionRoutine(Irp, write_completion, context, TRUE, TRUE, TRUE);
+    Irp->UserEvent = &context.Event;
 
+    IoSetCompletionRoutine(Irp, write_completion, &context, TRUE, TRUE, TRUE);
+
     Status = IoCallDriver(device, Irp);
-    
+
     if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&context->Event, Executive, KernelMode, FALSE, NULL);
-        Status = context->iosb.Status;
+        KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+        Status = context.iosb.Status;
     }
-    
+
     if (!NT_SUCCESS(Status)) {
         ERR("IoCallDriver returned %08x\n", Status);
     }
-    
+
     if (device->Flags & DO_DIRECT_IO) {
         MmUnlockPages(Irp->MdlAddress);
         IoFreeMdl(Irp->MdlAddress);
     }
-    
+
 exit:
     IoFreeIrp(Irp);
-    
-exit2:
-    if (context)
-        ExFreePool(context);
-    
+
     return Status;
 }
 
+static void add_trim_entry(device* dev, UINT64 address, UINT64 size) {
+    space* s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
+    if (!s) {
+        ERR("out of memory\n");
+        return;
+    }
+
+    s->address = address;
+    s->size = size;
+    dev->num_trim_entries++;
+
+    InsertTailList(&dev->trim_list, &s->list_entry);
+}
+
 static void clean_space_cache_chunk(device_extension* Vcb, chunk* c) {
-    // FIXME - loop through c->deleting and do TRIM if device supports it
-    // FIXME - also find way of doing TRIM of dropped chunks
-    
+    ULONG type;
+
+    if (Vcb->trim && !Vcb->options.no_trim) {
+        if (c->chunk_item->type & BLOCK_FLAG_DUPLICATE)
+            type = BLOCK_FLAG_DUPLICATE;
+        else if (c->chunk_item->type & BLOCK_FLAG_RAID0)
+            type = BLOCK_FLAG_RAID0;
+        else if (c->chunk_item->type & BLOCK_FLAG_RAID1)
+            type = BLOCK_FLAG_DUPLICATE;
+        else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
+            type = BLOCK_FLAG_RAID10;
+        else if (c->chunk_item->type & BLOCK_FLAG_RAID5)
+            type = BLOCK_FLAG_RAID5;
+        else if (c->chunk_item->type & BLOCK_FLAG_RAID6)
+            type = BLOCK_FLAG_RAID6;
+        else // SINGLE
+            type = BLOCK_FLAG_DUPLICATE;
+    }
+
     while (!IsListEmpty(&c->deleting)) {
         space* s = CONTAINING_RECORD(c->deleting.Flink, space, list_entry);
-        
+
+        if (Vcb->trim && !Vcb->options.no_trim && (!Vcb->options.no_barrier || !(c->chunk_item->type & BLOCK_FLAG_METADATA))) {
+            CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
+
+            if (type == BLOCK_FLAG_DUPLICATE) {
+                UINT16 i;
+
+                for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                    if (c->devices[i] && c->devices[i]->devobj && !c->devices[i]->readonly && c->devices[i]->trim)
+                        add_trim_entry(c->devices[i], s->address - c->offset + cis[i].offset, s->size);
+                }
+            } else if (type == BLOCK_FLAG_RAID0) {
+                UINT64 startoff, endoff;
+                UINT16 startoffstripe, endoffstripe, i;
+
+                get_raid0_offset(s->address - c->offset, c->chunk_item->stripe_length, c->chunk_item->num_stripes, &startoff, &startoffstripe);
+                get_raid0_offset(s->address - c->offset + s->size - 1, c->chunk_item->stripe_length, c->chunk_item->num_stripes, &endoff, &endoffstripe);
+
+                for (i = 0; i < c->chunk_item->num_stripes; i++) {
+                    if (c->devices[i] && c->devices[i]->devobj && !c->devices[i]->readonly && c->devices[i]->trim) {
+                        UINT64 stripestart, stripeend;
+
+                        if (startoffstripe > i)
+                            stripestart = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+                        else if (startoffstripe == i)
+                            stripestart = startoff;
+                        else
+                            stripestart = startoff - (startoff % c->chunk_item->stripe_length);
+
+                        if (endoffstripe > i)
+                            stripeend = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+                        else if (endoffstripe == i)
+                            stripeend = endoff + 1;
+                        else
+                            stripeend = endoff - (endoff % c->chunk_item->stripe_length);
+
+                        if (stripestart != stripeend)
+                            add_trim_entry(c->devices[i], stripestart + cis[i].offset, stripeend - stripestart);
+                    }
+                }
+            } else if (type == BLOCK_FLAG_RAID10) {
+                UINT64 startoff, endoff;
+                UINT16 sub_stripes, startoffstripe, endoffstripe, i;
+
+                sub_stripes = max(1, c->chunk_item->sub_stripes);
+
+                get_raid0_offset(s->address - c->offset, c->chunk_item->stripe_length, c->chunk_item->num_stripes / sub_stripes, &startoff, &startoffstripe);
+                get_raid0_offset(s->address - c->offset + s->size - 1, c->chunk_item->stripe_length, c->chunk_item->num_stripes / sub_stripes, &endoff, &endoffstripe);
+
+                startoffstripe *= sub_stripes;
+                endoffstripe *= sub_stripes;
+
+                for (i = 0; i < c->chunk_item->num_stripes; i += sub_stripes) {
+                    ULONG j;
+                    UINT64 stripestart, stripeend;
+
+                    if (startoffstripe > i)
+                        stripestart = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+                    else if (startoffstripe == i)
+                        stripestart = startoff;
+                    else
+                        stripestart = startoff - (startoff % c->chunk_item->stripe_length);
+
+                    if (endoffstripe > i)
+                        stripeend = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
+                    else if (endoffstripe == i)
+                        stripeend = endoff + 1;
+                    else
+                        stripeend = endoff - (endoff % c->chunk_item->stripe_length);
+
+                    if (stripestart != stripeend) {
+                        for (j = 0; j < sub_stripes; j++) {
+                            if (c->devices[i+j] && c->devices[i+j]->devobj && !c->devices[i+j]->readonly && c->devices[i+j]->trim)
+                                add_trim_entry(c->devices[i+j], stripestart + cis[i+j].offset, stripeend - stripestart);
+                        }
+                    }
+                }
+            }
+            // FIXME - RAID5(?), RAID6(?)
+        }
+
         RemoveEntryList(&s->list_entry);
         ExFreePool(s);
     }
 }
 
+typedef struct {
+    DEVICE_MANAGE_DATA_SET_ATTRIBUTES* dmdsa;
+    ATA_PASS_THROUGH_EX apte;
+    PIRP Irp;
+    IO_STATUS_BLOCK iosb;
+} ioctl_context_stripe;
+
+typedef struct {
+    KEVENT Event;
+    LONG left;
+    ioctl_context_stripe* stripes;
+} ioctl_context;
+
+_Function_class_(IO_COMPLETION_ROUTINE)
+#ifdef __REACTOS__
+static NTSTATUS NTAPI ioctl_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#else
+static NTSTATUS ioctl_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#endif
+    ioctl_context* context = (ioctl_context*)conptr;
+    LONG left2 = InterlockedDecrement(&context->left);
+
+    UNUSED(DeviceObject);
+    UNUSED(Irp);
+
+    if (left2 == 0)
+        KeSetEvent(&context->Event, 0, FALSE);
+
+    return STATUS_MORE_PROCESSING_REQUIRED;
+}
+
 static void clean_space_cache(device_extension* Vcb) {
+    LIST_ENTRY* le;
     chunk* c;
-    
+    ULONG num;
+
     TRACE("(%p)\n", Vcb);
-    
-    while (!IsListEmpty(&Vcb->chunks_changed)) {
-        c = CONTAINING_RECORD(Vcb->chunks_changed.Flink, chunk, list_entry_changed);
-        
-        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
-        clean_space_cache_chunk(Vcb, c);
-        RemoveEntryList(&c->list_entry_changed);
-        c->list_entry_changed.Flink = NULL;
-        
-        ExReleaseResourceLite(&c->lock);
+
+    ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (c->space_changed) {
+            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+            if (c->space_changed)
+                clean_space_cache_chunk(Vcb, c);
+
+            c->space_changed = FALSE;
+
+            ExReleaseResourceLite(&c->lock);
+        }
+
+        le = le->Flink;
     }
+
+    ExReleaseResourceLite(&Vcb->chunk_lock);
+
+    if (Vcb->trim && !Vcb->options.no_trim) {
+        ioctl_context context;
+        ULONG total_num;
+
+        context.left = 0;
+
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (dev->devobj && !dev->readonly && dev->trim && dev->num_trim_entries > 0)
+                context.left++;
+
+            le = le->Flink;
+        }
+
+        if (context.left == 0)
+            return;
+
+        total_num = context.left;
+        num = 0;
+
+        KeInitializeEvent(&context.Event, NotificationEvent, FALSE);
+
+        context.stripes = ExAllocatePoolWithTag(NonPagedPool, sizeof(ioctl_context_stripe) * context.left, ALLOC_TAG);
+        if (!context.stripes) {
+            ERR("out of memory\n");
+            return;
+        }
+
+        RtlZeroMemory(context.stripes, sizeof(ioctl_context_stripe) * context.left);
+
+        le = Vcb->devices.Flink;
+        while (le != &Vcb->devices) {
+            device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+            if (dev->devobj && !dev->readonly && dev->trim && dev->num_trim_entries > 0) {
+                LIST_ENTRY* le2;
+                ioctl_context_stripe* stripe = &context.stripes[num];
+                DEVICE_DATA_SET_RANGE* ranges;
+                ULONG datalen = (ULONG)sector_align(sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), sizeof(UINT64)) + (dev->num_trim_entries * sizeof(DEVICE_DATA_SET_RANGE)), i;
+                PIO_STACK_LOCATION IrpSp;
+
+                stripe->dmdsa = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
+                if (!stripe->dmdsa) {
+                    ERR("out of memory\n");
+                    goto nextdev;
+                }
+
+                stripe->dmdsa->Size = sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES);
+                stripe->dmdsa->Action = DeviceDsmAction_Trim;
+                stripe->dmdsa->Flags = DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED;
+                stripe->dmdsa->ParameterBlockOffset = 0;
+                stripe->dmdsa->ParameterBlockLength = 0;
+                stripe->dmdsa->DataSetRangesOffset = (ULONG)sector_align(sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), sizeof(UINT64));
+                stripe->dmdsa->DataSetRangesLength = dev->num_trim_entries * sizeof(DEVICE_DATA_SET_RANGE);
+
+                ranges = (DEVICE_DATA_SET_RANGE*)((UINT8*)stripe->dmdsa + stripe->dmdsa->DataSetRangesOffset);
+
+                i = 0;
+
+                le2 = dev->trim_list.Flink;
+                while (le2 != &dev->trim_list) {
+                    space* s = CONTAINING_RECORD(le2, space, list_entry);
+
+                    ranges[i].StartingOffset = s->address;
+                    ranges[i].LengthInBytes = s->size;
+                    i++;
+
+                    le2 = le2->Flink;
+                }
+
+                stripe->Irp = IoAllocateIrp(dev->devobj->StackSize, FALSE);
+
+                if (!stripe->Irp) {
+                    ERR("IoAllocateIrp failed\n");
+                    goto nextdev;
+                }
+
+                IrpSp = IoGetNextIrpStackLocation(stripe->Irp);
+                IrpSp->MajorFunction = IRP_MJ_DEVICE_CONTROL;
+
+                IrpSp->Parameters.DeviceIoControl.IoControlCode = IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES;
+                IrpSp->Parameters.DeviceIoControl.InputBufferLength = datalen;
+                IrpSp->Parameters.DeviceIoControl.OutputBufferLength = 0;
+
+                stripe->Irp->AssociatedIrp.SystemBuffer = stripe->dmdsa;
+                stripe->Irp->Flags |= IRP_BUFFERED_IO;
+                stripe->Irp->UserBuffer = NULL;
+                stripe->Irp->UserIosb = &stripe->iosb;
+
+                IoSetCompletionRoutine(stripe->Irp, ioctl_completion, &context, TRUE, TRUE, TRUE);
+
+                IoCallDriver(dev->devobj, stripe->Irp);
+
+nextdev:
+                while (!IsListEmpty(&dev->trim_list)) {
+                    space* s = CONTAINING_RECORD(RemoveHeadList(&dev->trim_list), space, list_entry);
+                    ExFreePool(s);
+                }
+
+                dev->num_trim_entries = 0;
+
+                num++;
+            }
+
+            le = le->Flink;
+        }
+
+        KeWaitForSingleObject(&context.Event, Executive, KernelMode, FALSE, NULL);
+
+        for (num = 0; num < total_num; num++) {
+            if (context.stripes[num].dmdsa)
+                ExFreePool(context.stripes[num].dmdsa);
+        }
+
+        ExFreePool(context.stripes);
+    }
 }
 
-static BOOL trees_consistent(device_extension* Vcb, LIST_ENTRY* rollback) {
+static BOOL trees_consistent(device_extension* Vcb) {
     ULONG maxsize = Vcb->superblock.node_size - sizeof(tree_header);
     LIST_ENTRY* le;
-    
+
     le = Vcb->trees.Flink;
     while (le != &Vcb->trees) {
         tree* t = CONTAINING_RECORD(le, tree, list_entry);
-        
+
         if (t->write) {
             if (t->header.num_items == 0 && t->parent) {
 #ifdef DEBUG_WRITE_LOOPS
@@ -183,7 +466,7 @@
 #endif
                 return FALSE;
             }
-            
+
             if (t->size > maxsize) {
 #ifdef DEBUG_WRITE_LOOPS
                 ERR("overlarge tree found (%u > %u), looping again\n", t->size, maxsize);
@@ -190,7 +473,7 @@
 #endif
                 return FALSE;
             }
-            
+
             if (!t->has_new_address) {
 #ifdef DEBUG_WRITE_LOOPS
                 ERR("tree found without new address, looping again\n");
@@ -198,79 +481,86 @@
                 return FALSE;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     return TRUE;
 }
 
-static NTSTATUS add_parents(device_extension* Vcb, PIRP Irp, LIST_ENTRY* rollback) {
-    UINT8 level;
+static NTSTATUS add_parents(device_extension* Vcb, PIRP Irp) {
+    ULONG level;
     LIST_ENTRY* le;
-    
+
     for (level = 0; level <= 255; level++) {
         BOOL nothing_found = TRUE;
-        
+
         TRACE("level = %u\n", level);
-        
+
         le = Vcb->trees.Flink;
         while (le != &Vcb->trees) {
             tree* t = CONTAINING_RECORD(le, tree, list_entry);
-            
+
             if (t->write && t->header.level == level) {
                 TRACE("tree %p: root = %llx, level = %x, parent = %p\n", t, t->header.tree_id, t->header.level, t->parent);
-                
+
                 nothing_found = FALSE;
-                
+
                 if (t->parent) {
                     if (!t->parent->write)
                         TRACE("adding tree %p (level %x)\n", t->parent, t->header.level);
-                        
+
                     t->parent->write = TRUE;
                 } else if (t->root != Vcb->root_root && t->root != Vcb->chunk_root) {
                     KEY searchkey;
                     traverse_ptr tp;
                     NTSTATUS Status;
-                    
+
                     searchkey.obj_id = t->root->id;
                     searchkey.obj_type = TYPE_ROOT_ITEM;
                     searchkey.offset = 0xffffffffffffffff;
-                    
+
                     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
                     if (!NT_SUCCESS(Status)) {
                         ERR("error - find_item returned %08x\n", Status);
                         return Status;
                     }
-                    
+
                     if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
                         ERR("could not find ROOT_ITEM for tree %llx\n", searchkey.obj_id);
                         return STATUS_INTERNAL_ERROR;
                     }
-                    
+
                     if (tp.item->size < sizeof(ROOT_ITEM)) { // if not full length, delete and create new entry
                         ROOT_ITEM* ri = ExAllocatePoolWithTag(PagedPool, sizeof(ROOT_ITEM), ALLOC_TAG);
-                        
+
                         if (!ri) {
                             ERR("out of memory\n");
                             return STATUS_INSUFFICIENT_RESOURCES;
                         }
-                        
+
                         RtlCopyMemory(ri, &t->root->root_item, sizeof(ROOT_ITEM));
-                        
-                        delete_tree_item(Vcb, &tp, rollback);
-                        
-                        if (!insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, Irp, rollback)) {
-                            ERR("insert_tree_item failed\n");
-                            return STATUS_INTERNAL_ERROR;
+
+                        Status = delete_tree_item(Vcb, &tp);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("delete_tree_item returned %08x\n", Status);
+                            ExFreePool(ri);
+                            return Status;
                         }
+
+                        Status = insert_tree_item(Vcb, Vcb->root_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, ri, sizeof(ROOT_ITEM), NULL, Irp);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("insert_tree_item returned %08x\n", Status);
+                            ExFreePool(ri);
+                            return Status;
+                        }
                     }
                 }
             }
-            
+
             le = le->Flink;
         }
-        
+
         if (nothing_found)
             break;
     }
@@ -278,7 +568,7 @@
     return STATUS_SUCCESS;
 }
 
-static void add_parents_to_cache(device_extension* Vcb, tree* t) {
+static void add_parents_to_cache(tree* t) {
     while (t->parent) {
         t = t->parent;
         t->write = TRUE;
@@ -286,35 +576,37 @@
 }
 
 static BOOL insert_tree_extent_skinny(device_extension* Vcb, UINT8 level, UINT64 root_id, chunk* c, UINT64 address, PIRP Irp, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     EXTENT_ITEM_SKINNY_METADATA* eism;
     traverse_ptr insert_tp;
-    
+
     eism = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_ITEM_SKINNY_METADATA), ALLOC_TAG);
     if (!eism) {
         ERR("out of memory\n");
         return FALSE;
     }
-    
+
     eism->ei.refcount = 1;
     eism->ei.generation = Vcb->superblock.generation;
     eism->ei.flags = EXTENT_ITEM_TREE_BLOCK;
     eism->type = TYPE_TREE_BLOCK_REF;
     eism->tbr.offset = root_id;
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_METADATA_ITEM, level, eism, sizeof(EXTENT_ITEM_SKINNY_METADATA), &insert_tp, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_METADATA_ITEM, level, eism, sizeof(EXTENT_ITEM_SKINNY_METADATA), &insert_tp, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(eism);
         return FALSE;
     }
-    
+
     ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-    
-    space_list_subtract(Vcb, c, FALSE, address, Vcb->superblock.node_size, rollback);
 
+    space_list_subtract(c, FALSE, address, Vcb->superblock.node_size, rollback);
+
     ExReleaseResourceLite(&c->lock);
-    
-    add_parents_to_cache(Vcb, insert_tp.tree);
-    
+
+    add_parents_to_cache(insert_tp.tree);
+
     return TRUE;
 }
 
@@ -321,18 +613,30 @@
 BOOL find_metadata_address_in_chunk(device_extension* Vcb, chunk* c, UINT64* address) {
     LIST_ENTRY* le;
     space* s;
-    
+
     TRACE("(%p, %llx, %p)\n", Vcb, c->offset, address);
-    
+
+    if (Vcb->superblock.node_size > c->chunk_item->size - c->used)
+        return FALSE;
+
+    if (!c->cache_loaded) {
+        NTSTATUS Status = load_cache_chunk(Vcb, c, NULL);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("load_cache_chunk returned %08x\n", Status);
+            return FALSE;
+        }
+    }
+
     if (IsListEmpty(&c->space_size))
         return FALSE;
-    
+
     if (!c->last_alloc_set) {
         s = CONTAINING_RECORD(c->space.Blink, space, list_entry);
-        
+
         c->last_alloc = s->address;
         c->last_alloc_set = TRUE;
-        
+
         if (s->size >= Vcb->superblock.node_size) {
             *address = s->address;
             c->last_alloc += Vcb->superblock.node_size;
@@ -339,24 +643,24 @@
             return TRUE;
         }
     }
-    
+
     le = c->space.Flink;
     while (le != &c->space) {
         s = CONTAINING_RECORD(le, space, list_entry);
-        
+
         if (s->address <= c->last_alloc && s->address + s->size >= c->last_alloc + Vcb->superblock.node_size) {
             *address = c->last_alloc;
             c->last_alloc += Vcb->superblock.node_size;
             return TRUE;
         }
-        
+
         le = le->Flink;
     }
-    
+
     le = c->space_size.Flink;
     while (le != &c->space_size) {
         s = CONTAINING_RECORD(le, space, list_entry_size);
-        
+
         if (s->size == Vcb->superblock.node_size) {
             *address = s->address;
             c->last_alloc = s->address + Vcb->superblock.node_size;
@@ -364,48 +668,49 @@
         } else if (s->size < Vcb->superblock.node_size) {
             if (le == c->space_size.Flink)
                 return FALSE;
-            
+
             s = CONTAINING_RECORD(le->Blink, space, list_entry_size);
-            
+
             *address = s->address;
             c->last_alloc = s->address + Vcb->superblock.node_size;
-            
+
             return TRUE;
         }
-        
+
         le = le->Flink;
     }
-    
+
     s = CONTAINING_RECORD(c->space_size.Blink, space, list_entry_size);
-    
+
     if (s->size > Vcb->superblock.node_size) {
         *address = s->address;
         c->last_alloc = s->address + Vcb->superblock.node_size;
         return TRUE;
     }
-    
+
     return FALSE;
 }
 
 static BOOL insert_tree_extent(device_extension* Vcb, UINT8 level, UINT64 root_id, chunk* c, UINT64* new_address, PIRP Irp, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     UINT64 address;
     EXTENT_ITEM_TREE2* eit2;
     traverse_ptr insert_tp;
-    
+
     TRACE("(%p, %x, %llx, %p, %p, %p, %p)\n", Vcb, level, root_id, c, new_address, rollback);
-    
+
     if (!find_metadata_address_in_chunk(Vcb, c, &address))
         return FALSE;
-    
+
     if (Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA) {
         BOOL b = insert_tree_extent_skinny(Vcb, level, root_id, c, address, Irp, rollback);
-        
+
         if (b)
             *new_address = address;
-        
+
         return b;
     }
-    
+
     eit2 = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_ITEM_TREE2), ALLOC_TAG);
     if (!eit2) {
         ERR("out of memory\n");
@@ -415,65 +720,45 @@
     eit2->eit.extent_item.refcount = 1;
     eit2->eit.extent_item.generation = Vcb->superblock.generation;
     eit2->eit.extent_item.flags = EXTENT_ITEM_TREE_BLOCK;
-//     eit2->eit.firstitem = wt->firstitem;
     eit2->eit.level = level;
     eit2->type = TYPE_TREE_BLOCK_REF;
     eit2->tbr.offset = root_id;
-    
-// #ifdef DEBUG_PARANOID
-//     if (wt->firstitem.obj_type == 0xcc) { // TESTING
-//         ERR("error - firstitem not set (wt = %p, tree = %p, address = %x)\n", wt, wt->tree, (UINT32)address);
-//         ERR("num_items = %u, level = %u, root = %x, delete = %u\n", wt->tree->header.num_items, wt->tree->header.level, (UINT32)wt->tree->root->id, wt->delete);
-//         int3;
-//     }
-// #endif
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_EXTENT_ITEM, Vcb->superblock.node_size, eit2, sizeof(EXTENT_ITEM_TREE2), &insert_tp, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, address, TYPE_EXTENT_ITEM, Vcb->superblock.node_size, eit2, sizeof(EXTENT_ITEM_TREE2), &insert_tp, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(eit2);
         return FALSE;
     }
-    
+
     ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-    
-    space_list_subtract(Vcb, c, FALSE, address, Vcb->superblock.node_size, rollback);
-    
+
+    space_list_subtract(c, FALSE, address, Vcb->superblock.node_size, rollback);
+
     ExReleaseResourceLite(&c->lock);
 
-    add_parents_to_cache(Vcb, insert_tp.tree);
-    
+    add_parents_to_cache(insert_tp.tree);
+
     *new_address = address;
-    
+
     return TRUE;
 }
 
 NTSTATUS get_tree_new_address(device_extension* Vcb, tree* t, PIRP Irp, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     chunk *origchunk = NULL, *c;
     LIST_ENTRY* le;
     UINT64 flags, addr;
-    
+
     if (t->root->id == BTRFS_ROOT_CHUNK)
         flags = Vcb->system_flags;
     else
         flags = Vcb->metadata_flags;
-    
-//     TRACE("flags = %x\n", (UINT32)wt->flags);
-    
-//     if (!chunk_test) { // TESTING
-//         if ((c = alloc_chunk(Vcb, flags))) {
-//             if ((c->chunk_item->size - c->used) >= Vcb->superblock.node_size) {
-//                 if (insert_tree_extent(Vcb, t, c)) {
-//                     chunk_test = TRUE;
-//                     return STATUS_SUCCESS;
-//                 }
-//             }
-//         }
-//     }
-    
+
     if (t->has_address) {
         origchunk = get_chunk_from_address(Vcb, t->header.address);
-        
-        if (!origchunk->readonly && !origchunk->reloc && origchunk->chunk_item->type == flags &&
+
+        if (origchunk && !origchunk->readonly && !origchunk->reloc && origchunk->chunk_item->type == flags &&
             insert_tree_extent(Vcb, t->header.level, t->root->id, origchunk, &addr, Irp, rollback)) {
             t->new_address = addr;
             t->has_new_address = TRUE;
